## piglit 0.0~git20250409.af62c0dea

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4...3.28)

if (POLICY CMP0072)
        cmake_policy (SET CMP0072 OLD)
endif()
if (POLICY CMP0148)
        cmake_policy (SET CMP0148 OLD)
endif()

project (piglit)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")

INCLUDE (GNUInstallDirs)
INCLUDE (CheckCCompilerFlag)
INCLUDE (CheckCSourceCompiles)
INCLUDE (CheckCXXCompilerFlag)
INCLUDE (CheckFunctionExists)
INCLUDE (CheckSymbolExists)
INCLUDE (CheckIncludeFile)
INCLUDE (FindPkgConfig)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	set(DEFAULT_EGL ON)
	set(DEFAULT_GLX ON)
	set(DEFAULT_WGL OFF)

	set(DEFAULT_WAFFLE ON)

	set(DEFAULT_GBM ON)
	set(DEFAULT_WAYLAND ON)
	set(DEFAULT_X11 ON)

	set(DEFAULT_GLES_TESTS_BUILD ON)
	set(DEFAULT_VK_TESTS_BUILD ON)
elseif(APPLE)
	set(DEFAULT_EGL OFF)
	set(DEFAULT_GLX OFF)
	set(DEFAULT_WGL OFF)

	set(DEFAULT_WAFFLE OFF)

	set(DEFAULT_GBM OFF)
	set(DEFAULT_WAYLAND OFF)
	set(DEFAULT_X11 OFF)

	set(DEFAULT_GLES_TESTS_BUILD OFF)
	set(DEFAULT_VK_TESTS_BUILD OFF)
elseif(WIN32)
	set(DEFAULT_EGL OFF)
	set(DEFAULT_GLX OFF)
	set(DEFAULT_WGL ON)

	set(DEFAULT_WAFFLE OFF)

	set(DEFAULT_GBM OFF)
	set(DEFAULT_WAYLAND OFF)
	set(DEFAULT_X11 OFF)

	set(DEFAULT_GLES_TESTS_BUILD OFF)
	set(DEFAULT_VK_TESTS_BUILD OFF)
else()
	message(FATAL_ERROR "Unsupported platform")
endif()

option(PIGLIT_SSE2 "Build with SSE2 support on 32-bit x86 architecture" ON)

option(PIGLIT_USE_WAFFLE "Use Waffle in place of GLUT" ${DEFAULT_WAFFLE})

option(PIGLIT_USE_GBM "Use GBM" ${DEFAULT_GBM})
option(PIGLIT_USE_WAYLAND "Use Wayland" ${DEFAULT_WAYLAND})
option(PIGLIT_USE_X11 "Use X11" ${DEFAULT_X11})

option(PIGLIT_BUILD_EGL_TESTS "Build tests that require EGL" ${DEFAULT_EGL})
option(PIGLIT_BUILD_GLX_TESTS "Build tests that require GLX" ${DEFAULT_GLX})
option(PIGLIT_BUILD_WGL_TESTS "Build tests that require WGL" ${DEFAULT_WGL})

option(PIGLIT_BUILD_GL_TESTS "Build tests for OpenGL" ON)
option(PIGLIT_BUILD_GLES1_TESTS "Build tests for OpenGL ES1" ${DEFAULT_GLES_TESTS_BUILD})
option(PIGLIT_BUILD_GLES2_TESTS "Build tests for OpenGL ES2" ${DEFAULT_GLES_TESTS_BUILD})
option(PIGLIT_BUILD_GLES3_TESTS "Build tests for OpenGL ES3" ${DEFAULT_GLES_TESTS_BUILD})
option(PIGLIT_BUILD_CL_TESTS "Build tests for OpenCL" OFF)
option(PIGLIT_BUILD_VK_TESTS "Build tests for Vulkan" ${DEFAULT_VK_TESTS_BUILD})

option(PIGLIT_BUILD_DMA_BUF_TESTS "Build tests that use dma_buf" ${DEFAULT_GBM})


find_package(Threads)
find_package(PNG)
if(PNG_FOUND)
	add_definitions(-DPIGLIT_HAS_PNG)
endif(PNG_FOUND)

if(PIGLIT_BUILD_GLX_TESTS AND NOT PIGLIT_USE_X11)
	message(FATAL_ERROR "X11 has to be enabled for GLX to build")
endif()

if(PIGLIT_BUILD_DMA_BUF_TESTS AND NOT PIGLIT_USE_GBM)
	message(FATAL_ERROR "PIGLIT_BUILD_DMA_BUF_TESTS require GBM")
endif()

if(PIGLIT_BUILD_EGL_TESTS AND NOT PIGLIT_USE_WAFFLE)
	message(FATAL_ERROR "Waffle has to be enabled for EGL tests to build")
endif()

if(PIGLIT_USE_X11)
	find_package(X11 REQUIRED)
	set(PIGLIT_HAS_X11 True)
	add_definitions(-DPIGLIT_HAS_X11)
endif()

if(PIGLIT_BUILD_GL_TESTS)
	find_package(OpenGL REQUIRED)
endif()

if(PIGLIT_USE_WAFFLE)
	if (NOT WIN32)
		pkg_check_modules(Waffle REQUIRED waffle-1)

		if(NOT Waffle_FOUND)
			message(FATAL_ERROR "Failed to find Waffle. If Waffle "
			"is not packaged for your distribution, you can get "
			"it at https://gitlab.freedesktop.org/mesa/waffle."
		)
		endif()

		# Check the installed waffle version.
		#
		# We cannot reliably check the version with pkg_check_modules(), but
		# instead must check the version manually as below. The problem is that,
		# if one passes a required version to pkg_check_modules(), CMake
		# validates the required version at most once for the lifetime of the
		# source tree.  If someone changes the required version by editing the
		# CMakeLists, CMake fails to detect the new requirement.
		set(Waffle_REQUIRED_VERSION "1.6.0")
		if(Waffle_VERSION VERSION_LESS Waffle_REQUIRED_VERSION)
			message(FATAL_ERROR "Found waffle-${Waffle_VERSION}, but "
			"piglit requires waffle-${Waffle_REQUIRED_VERSION}")
		endif()
	else ()
		find_path(Waffle_INCLUDE_DIRS waffle.h)
		find_library(Waffle_LDFLAGS waffle-1)
		if(Waffle_INCLUDE_DIRS AND Waffle_LDFLAGS)
			set(Waffle_FOUND TRUE)
		else()
			message(FATAL_ERROR "Failed to find Waffle. Get and build Waffle from "
				"https://gitlab.freedesktop.org/mesa/waffle and set "
				"Waffle_INCLUDE_DIRS and Waffle_LDFLAGS variables accordingly."
			)
		endif()
	endif ()

	add_definitions(-DPIGLIT_USE_WAFFLE)
	add_definitions(-DWAFFLE_API_VERSION=0x0103)
else()
	find_package(GLUT REQUIRED)
endif(PIGLIT_USE_WAFFLE)

if(PIGLIT_BUILD_GLES1_TESTS AND (NOT PIGLIT_USE_WAFFLE OR NOT PIGLIT_BUILD_EGL_TESTS))
	message(FATAL_ERROR "Option PIGLIT_BUILD_GLES1_TESTS requires EGL and PIGLIT_USE_WAFFLE")
endif()
if(PIGLIT_BUILD_GLES2_TESTS AND (NOT PIGLIT_USE_WAFFLE OR NOT PIGLIT_BUILD_EGL_TESTS))
	message(FATAL_ERROR "Option PIGLIT_BUILD_GLES2_TESTS requires EGL and PIGLIT_USE_WAFFLE")
endif()
if(PIGLIT_BUILD_GLES3_TESTS AND (NOT PIGLIT_USE_WAFFLE OR NOT PIGLIT_BUILD_EGL_TESTS))
	message(FATAL_ERROR "Option PIGLIT_BUILD_GLES3_TESTS requires EGL and PIGLIT_USE_WAFFLE")
endif()

if(PIGLIT_BUILD_CL_TESTS)
	find_package(OpenCL 1.2 REQUIRED)
endif(PIGLIT_BUILD_CL_TESTS)


if(PIGLIT_USE_GBM)
	pkg_check_modules(GBM REQUIRED gbm>=17.1)
	set(PIGLIT_HAS_GBM True)
	add_definitions(-DPIGLIT_HAS_GBM)
	set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${GBM_LIBRARIES})
	set(CMAKE_REQUIRED_LINK_OPTIONS ${GBM_LDFLAGS})
	include_directories(${GBM_INCLUDE_DIRS})

	CHECK_FUNCTION_EXISTS(gbm_bo_map PIGLIT_HAS_GBM_BO_MAP)
	if (PIGLIT_HAS_GBM_BO_MAP)
		add_definitions(-DPIGLIT_HAS_GBM_BO_MAP)
	endif()

	CHECK_FUNCTION_EXISTS(gbm_bo_get_fd_for_plane PIGLIT_HAS_GBM_BO_GET_FD_FOR_PLANE)
	if (PIGLIT_HAS_GBM_BO_GET_FD_FOR_PLANE)
		add_definitions(-DPIGLIT_HAS_GBM_BO_GET_FD_FOR_PLANE)
	endif()
endif()

if(PIGLIT_USE_WAYLAND)
	pkg_check_modules(WAYLAND REQUIRED wayland-client wayland-egl)
	set(PIGLIT_HAS_WAYLAND True)
	add_definitions(-DPIGLIT_HAS_WAYLAND)
	include_directories(${WAYLAND_INCLUDE_DIRS})

	FIND_LIBRARY(HAVE_XKBCOMMON NAMES xkbcommon)
	if(NOT HAVE_XKBCOMMON)
		message(FATAL_ERROR "Wayland support requires xkbcommon. "
			"Failed to find xkbcommon library.")
	endif()
	pkg_check_modules(XKBCOMMON QUIET xkbcommon)

	pkg_check_modules(WaylandProtocols REQUIRED wayland-protocols>=1.24)
	pkg_get_variable(WaylandProtocols_DATADIR wayland-protocols pkgdatadir)
	if (NOT WaylandProtocols_DATADIR)
		message(FATAL_ERROR "Failed to find wayland-protocols XML path")
	endif()

	pkg_check_modules(WaylandScanner REQUIRED wayland-scanner)
	pkg_get_variable(WaylandScannerPath wayland-scanner wayland_scanner)
	if (NOT WaylandScannerPath)
		message(FATAL_ERROR "Failed to find wayland-scanner path from pkg-config")
	endif()
	add_executable(WaylandScannerExe IMPORTED)
	set_property(TARGET WaylandScannerExe PROPERTY IMPORTED_LOCATION ${WaylandScannerPath})
endif()

if(PIGLIT_USE_X11 AND OPENGL_gl_LIBRARY AND PIGLIT_BUILD_GLX_TESTS)
	set(PIGLIT_HAS_GLX True)
	add_definitions(-DPIGLIT_HAS_GLX)
endif()

if(PIGLIT_BUILD_WGL_TESTS)
	set(PIGLIT_HAS_WGL True)
	add_definitions(-DPIGLIT_HAS_WGL)
endif()

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	pkg_check_modules(LIBDRM QUIET libdrm)
	pkg_check_modules(XCB QUIET xcb)
	pkg_check_modules(XCB_DRI2 QUIET xcb-dri2)
	pkg_check_modules(GLPROTO QUIET glproto)
	pkg_check_modules(LIBVULKAN QUIET vulkan)
ENDIF()

if(LIBDRM_FOUND)
	if(LIBDRM_VERSION VERSION_GREATER "2.4.109")
		set(PIGLIT_HAS_DRM_GET_DEVICE_BY_DEVID true)
	else()
		set(PIGLIT_HAS_DRM_GET_DEVICE_BY_DEVID false)
	endif()
endif()

if(PIGLIT_BUILD_VK_TESTS)
	if (NOT LIBVULKAN_FOUND)
		message(FATAL_ERROR "libvulkan required by vulkan tests not found")
	endif()

	find_program(GLSLANG_VALIDATOR NAMES glslangValidator)

	if (NOT GLSLANG_VALIDATOR)
		message(FATAL_ERROR "glslangValidator required by vulkan tests not found")
	endif()
endif(PIGLIT_BUILD_VK_TESTS)

# Choose to build tests that use dma_buf.
#
# Piglit's dma_buf utilities require xcb-dri2 to gain DRM authentication, and
# gbm_bo_map() to be available for generating dma_bufs, and libdrm for fourcc
# definitions.
#
if(PIGLIT_BUILD_DMA_BUF_TESTS)
	if(PIGLIT_HAS_GBM_BO_MAP AND LIBDRM_FOUND AND LIBDRM_VERSION VERSION_GREATER "2.4.97" AND XCB_DRI2_FOUND)
		set(PIGLIT_BUILD_DMA_BUF_TESTS_IS_VALID true)
	else()
		message(FATAL_ERROR
			"PIGLIT_BUILD_DMA_BUF_TESTS require libdrm, "
			"gbm_bo_map(), libdrm>=2.4.98 and xcb-dri2")
		set(PIGLIT_BUILD_DMA_BUF_TESTS_IS_VALID false)
	endif()
endif()

IF(PIGLIT_BUILD_GLX_TESTS)
	pkg_check_modules(GLPROTO REQUIRED glproto)
ENDIF()

if (NOT Python_ADDITIONAL_VERSIONS)
	set(Python_ADDITIONAL_VERSIONS 3.13 3.12 3.11 3.10 3.9 3.8 3.7 3.6)
endif()
find_package(PythonInterp REQUIRED)
find_package(PythonNumpy 1.13.0 REQUIRED)
find_package(PythonMako 1.0.2 REQUIRED)

pkg_search_module(BASH_COMPLETION bash-completion)

# Default to compiling with debug information (`gcc -g`):
if(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE Debug CACHE STRING
	"May be one of: None Debug RelWithDebInfo Release MinSizeRel" FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if (NOT MSVC)
	if (PIGLIT_SSE2 AND CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)")
		# enables SSE2 and precision used on x86-64 by default
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse")
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse")
	else()
		# degrade performance a bit, but enforce required precision
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffloat-store")
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffloat-store")
	endif()
	CHECK_C_COMPILER_FLAG("-Wall" C_COMPILER_FLAG_WALL)
	IF (C_COMPILER_FLAG_WALL)
		SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
	ENDIF (C_COMPILER_FLAG_WALL)
	CHECK_CXX_COMPILER_FLAG("-Wall" CXX_COMPILER_FLAG_WALL)
	IF (CXX_COMPILER_FLAG_WALL)
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
	ENDIF (CXX_COMPILER_FLAG_WALL)

	# Target C99.  GCC's default is gnu11 for 5.0 and newer, gnu89 for
	# older versions.
	check_c_compiler_flag ("-std=gnu99" C_COMPILER_FLAG_STD_GNU99)
	if (C_COMPILER_FLAG_STD_GNU99)
		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
	endif ()
	# MSVC does not support C99 variable length arrays
	CHECK_C_COMPILER_FLAG("-Werror=vla" C_COMPILER_FLAG_WEVLA)
	IF (C_COMPILER_FLAG_WEVLA)
		SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=vla")
	ENDIF ()
	# GCC allows void pointer arithmetic, but it is not part of ISO C and
	# in particular MSVC will throw `C2036: 'void *' : unknown size`
	check_c_compiler_flag ("-Werror=pointer-arith" C_COMPILER_FLAG_WEPOINTER_ARITH)
	if (C_COMPILER_FLAG_WEPOINTER_ARITH)
		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=pointer-arith")
	endif ()
	# MSVC only supports C99 variadic macros.  It doesn't support the
	# non-standard GNU named variadic macro syntax that's documented in
	# https://gcc.gnu.org/onlinedocs/cpp/Variadic-Macros.html
	#
	# XXX: on older GCC version this option has no effect unless -Wpedantic
	# is set, but this should be fixed on future GCC versions, per
	# https://gcc.gnu.org/ml/gcc-patches/2014-04/msg01459.html
	check_c_compiler_flag ("-Werror=variadic-macros" C_COMPILER_FLAG_WVARIADIC_MACROS)
	if (C_COMPILER_FLAG_WVARIADIC_MACROS)
		set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror=variadic-macros")
	endif ()

	CHECK_CXX_COMPILER_FLAG("-Wno-narrowing" CXX_COMPILER_FLAG_WNO_NARROWING)
	IF (CXX_COMPILER_FLAG_WNO_NARROWING)
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-narrowing")
	ENDIF (CXX_COMPILER_FLAG_WNO_NARROWING)
else ()
	# Adjust warnings
	add_definitions (-W3)
	add_definitions (-wd4018) # signed/unsigned mismatch
	add_definitions (-wd4244) # conversion from 'type1' to 'type2', possible loss of data
	add_definitions (-wd4305) # truncation from 'type1' to 'type2'
	add_definitions (-wd4800) # forcing value to bool 'true' or 'false' (performance warning)

	add_definitions (-D_CRT_SECURE_NO_DEPRECATE -D_CRT_SECURE_NO_WARNINGS -D_CRT_NONSTDC_NO_WARNINGS)

=== generated_tests/CMakeLists.txt ===
# Create a custom command that runs the Python script
# ${generator_script} to generate tests.
#
# A list of the files generated will be output to the file
# ${file_list}.  This can be used to run the custom command by itself,
# and is also used by the build system to tell when the files need to
# be rebuilt.
#
# The custom command will automatically depend on ${generator_script}.
# Additional dependencies can be supplied using additional arguments.
function(piglit_make_generated_tests file_list generator_script)
	# Add a custom command which executes ${generator_script}
	# during the build.
	add_custom_command(
		OUTPUT ${file_list}
		COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/${generator_script} > ${file_list}
		DEPENDS ${generator_script} ${ARGN}
		VERBATIM)
endfunction(piglit_make_generated_tests custom_target generator_script)

# Generators for OpenGL tests
piglit_make_generated_tests(
	builtin_packing_tests.list
	gen_builtin_packing_tests.py
	templates/gen_builtin_packing_tests/vs_unpack.shader_test.mako
	templates/gen_builtin_packing_tests/vs_pack.shader_test.mako
	templates/gen_builtin_packing_tests/fs_unpack.shader_test.mako
	templates/gen_builtin_packing_tests/fs_pack.shader_test.mako
	templates/gen_builtin_packing_tests/const_pack.shader_test.mako
	templates/gen_builtin_packing_tests/const_unpack.shader_test.mako
	)
piglit_make_generated_tests(
	builtin_uniform_tests.list
	gen_builtin_uniform_tests.py
	builtin_function.py)
piglit_make_generated_tests(
	constant_array_size_tests.list
	gen_constant_array_size_tests.py
	builtin_function.py)
piglit_make_generated_tests(
	const_builtin_equal_tests.list
	gen_const_builtin_equal_tests.py
	templates/gen_const_builtin_equal_tests/template.shader_test.mako
	)
piglit_make_generated_tests(
	tes_input_tests.list
	gen_tes_input_tests.py)
piglit_make_generated_tests(
	tcs_input_tests.list
	gen_tcs_input_tests.py)
piglit_make_generated_tests(
	interpolation_tests.list
	gen_interpolation_tests.py
	templates/gen_interpolation_tests/template.shader_test.mako
	)
piglit_make_generated_tests(
	non-lvalue_tests.list
	gen_non-lvalue_tests.py
	templates/gen_non-lvalue_tests/assignment.glsl_parser_test.mako
	templates/gen_non-lvalue_tests/out-parameter.glsl_parser_test.mako
	)
piglit_make_generated_tests(
	texture_query_lod_tests.list
	gen_texture_query_lod_tests.py
	templates/gen_texture_query_lod_tests/template.glsl_parser_test.mako
	)
piglit_make_generated_tests(
	shader_bit_encoding_tests.list
	gen_shader_bit_encoding_tests.py
	templates/gen_shader_bit_encoding_tests/template.shader_test.mako
	)
piglit_make_generated_tests(
	uniform-initializer_tests.list
	gen_uniform_initializer_tests.py
	templates/gen_uniform_initializer_tests/fs-initializer.shader_test.mako
	templates/gen_uniform_initializer_tests/vs-initializer.shader_test.mako
	templates/gen_uniform_initializer_tests/fs-initializer-from-const.shader_test.mako
	templates/gen_uniform_initializer_tests/vs-initializer-from-const.shader_test.mako
	templates/gen_uniform_initializer_tests/fs-initializer-set-by-API.shader_test.mako
	templates/gen_uniform_initializer_tests/vs-initializer-set-by-API.shader_test.mako
	templates/gen_uniform_initializer_tests/fs-initializer-set-by-other-stage.shader_test.mako
	templates/gen_uniform_initializer_tests/vs-initializer-set-by-other-stage.shader_test.mako
	)
piglit_make_generated_tests(
	ubo_tests.list
	random_ubo-arb_uniform_buffer_object.py)
piglit_make_generated_tests(
	interpolation-qualifier-built-in-variable.list
	interpolation-qualifier-built-in-variable.py
	templates/interpolation-qualifier-built-in-variable/fs-vs-unused.shader_test.mako
	templates/interpolation-qualifier-built-in-variable/vs-unused.shader_test.mako
	templates/interpolation-qualifier-built-in-variable/fs-unused.shader_test.mako
	templates/interpolation-qualifier-built-in-variable/vs-fs-flip.shader_test.mako
	templates/interpolation-qualifier-built-in-variable/vs-fs.shader_test.mako
	)
piglit_make_generated_tests(
	texture_lod_tests.list
	gen_texture_lod_tests.py
	templates/gen_texture_lod_tests/tex_grad.vert.mako
	templates/gen_texture_lod_tests/tex_grad.frag.mako
	templates/gen_texture_lod_tests/frag_lod.glsl_parser_test.mako
	)
piglit_make_generated_tests(
	gpu_shader4_tests.list
	gen_gpu_shader4_tests.py
	templates/gen_gpu_shader4_tests/binary.frag.mako       templates/gen_gpu_shader4_tests/texel_fetch.vert.mako   templates/gen_gpu_shader4_tests/tex.vert.mako
	templates/gen_gpu_shader4_tests/binary_op.frag.mako    templates/gen_gpu_shader4_tests/tex.frag.mako           templates/gen_gpu_shader4_tests/unary.frag.mako
	templates/gen_gpu_shader4_tests/binary_op.vert.mako    templates/gen_gpu_shader4_tests/tex_grad.frag.mako      templates/gen_gpu_shader4_tests/unary_op.frag.mako
	templates/gen_gpu_shader4_tests/binary.vert.mako       templates/gen_gpu_shader4_tests/tex_grad.vert.mako      templates/gen_gpu_shader4_tests/unary_op.vert.mako
	templates/gen_gpu_shader4_tests/ternary.frag.mako      templates/gen_gpu_shader4_tests/tex_lod.frag.mako       templates/gen_gpu_shader4_tests/unary.vert.mako
	templates/gen_gpu_shader4_tests/ternary.vert.mako      templates/gen_gpu_shader4_tests/tex_lod.vert.mako       templates/gen_gpu_shader4_tests/vec_compare.frag.mako
	templates/gen_gpu_shader4_tests/tex_bias.frag.mako     templates/gen_gpu_shader4_tests/texture_size.frag.mako  templates/gen_gpu_shader4_tests/vec_compare.vert.mako
	templates/gen_gpu_shader4_tests/texel_fetch.frag.mako  templates/gen_gpu_shader4_tests/texture_size.vert.mako
	)
piglit_make_generated_tests(
	outerproduct_invalid_params.list
	gen_outerproduct_invalid_params.py
	templates/gen_outerproduct_invalid_params/template.vert.mako
	)
piglit_make_generated_tests(
	outerproduct_tests.list
	gen_outerproduct_tests.py
	templates/gen_outerproduct_tests/template.shader_test.mako
	)

piglit_make_generated_tests(
	builtin_uniform_tests_fp64.list
	gen_builtin_uniform_tests_fp64.py
	builtin_function_fp64.py)
piglit_make_generated_tests(
	constant_array_size_tests_fp64.list
	gen_constant_array_size_tests_fp64.py
	builtin_function_fp64.py)
piglit_make_generated_tests(
	inout_fp64.list
	gen_inout_fp64.py
	templates/gen_inout_fp64/template.frag.mako
	templates/gen_inout_fp64/template.vert.mako
	)
piglit_make_generated_tests(
	flat_interpolation_qualifier.list
	gen_flat_interpolation_qualifier.py
	templates/gen_flat_interpolation_qualifier/compiler.mako
	templates/gen_flat_interpolation_qualifier/template.frag.mako
	)
piglit_make_generated_tests(
	conversion.list
	gen_conversion.py
	templates/gen_conversion/base.mako
	templates/gen_conversion/compiler.frag.mako
	templates/gen_conversion/compiler.geom.mako
	templates/gen_conversion/compiler.vert.mako
	templates/gen_conversion/compiler_base.mako
	templates/gen_conversion/execution-zero-sign.frag.shader_test.mako
	templates/gen_conversion/execution-zero-sign.geom.shader_test.mako
	templates/gen_conversion/execution-zero-sign.vert.shader_test.mako
	templates/gen_conversion/execution.frag.shader_test.mako
	templates/gen_conversion/execution.geom.shader_test.mako
	templates/gen_conversion/execution.vert.shader_test.mako
	templates/gen_conversion/execution_base.mako
	templates/gen_conversion/shader-zero-sign.frag.mako
	templates/gen_conversion/shader-zero-sign.geom.mako
	templates/gen_conversion/shader-zero-sign.vert.mako
	templates/gen_conversion/shader.frag.mako
	templates/gen_conversion/shader.geom.mako
	templates/gen_conversion/shader.vert.mako
	templates/gen_conversion/shader_base.mako
	)
piglit_make_generated_tests(
	shader_intel_conservative_rasterization.list
	gen_shader_intel_conservative_rasterization.py)
piglit_make_generated_tests(
	shader_precision_tests.list
	gen_shader_precision_tests.py
	builtin_function.py
	templates/gen_shader_precision_tests/vs.mako
	templates/gen_shader_precision_tests/fs.mako
	templates/gen_shader_precision_tests/gs.mako)
piglit_make_generated_tests(
	shader_image_load_store_tests.list
	gen_shader_image_load_store_tests.py)
piglit_make_generated_tests(
	shader_image_nv_image_formats_tests.list
	gen_shader_image_nv_image_formats_tests.py)
piglit_make_generated_tests(
	variable_index_read_tests.list
	gen_variable_index_read_tests.py
	templates/gen_variable_index_read_tests/vs.shader_test.mako
	templates/gen_variable_index_read_tests/fs.shader_test.mako
	templates/gen_variable_index_read_tests/helpers.mako)
piglit_make_generated_tests(
	gen_extensions_defined.list
	gen_extensions_defined.py
	templates/gen_extensions_defined/enabled.glsl.mako
	templates/gen_extensions_defined/disabled.glsl.mako
	templates/gen_extensions_defined/undefined-require.glsl.mako
	modules/glsl.py)
piglit_make_generated_tests(
	vp-tex.list
	gen_vp_tex.py
	templates/gen_vp_tex/helpers.mako
	templates/gen_vp_tex/arbvp.mako
	templates/gen_vp_tex/nvvp3.mako
	templates/gen_vp_tex/nvvp3_2.mako)
piglit_make_generated_tests(
	variable_index_write_tests.list
	gen_variable_index_write_tests.py
	templates/gen_variable_index_write_tests/vs.shader_test.mako
	templates/gen_variable_index_write_tests/fs.shader_test.mako
	templates/gen_variable_index_write_tests/helpers.mako)
piglit_make_generated_tests(
	vs_in_fp64.list
	gen_vs_in_fp64.py
	templates/gen_vs_in_fp64/columns.shader_test.mako
	templates/gen_vs_in_fp64/regular.shader_test.mako)
piglit_make_generated_tests(
	shader_framebuffer_fetch_tests.list
	gen_shader_framebuffer_fetch_tests.py)
piglit_make_generated_tests(
	intel_shader_integer_functions2_tests.list
	gen_intel_shader_integer_functions2_tests.py
	templates/gen_intel_shader_integer_functions2_tests/absoluteDifference.shader_test.mako
	templates/gen_intel_shader_integer_functions2_tests/addSaturate.shader_test.mako
	templates/gen_intel_shader_integer_functions2_tests/countLeadingZeros.shader_test.mako
	templates/gen_intel_shader_integer_functions2_tests/multiply32x16.shader_test.mako
	templates/gen_intel_shader_integer_functions2_tests/subtractSaturate.shader_test.mako)
piglit_make_generated_tests(
	inout_64bit.list
	gen_inout_64bit_tests.py)
piglit_make_generated_tests(
	interface_block_tests.list
	gen_interface_block_tests.py)

# OpenCL Test generators
piglit_make_generated_tests(
	builtin_cl_int_tests.list
	gen_cl_int_builtins.py)
piglit_make_generated_tests(
	cl_store_tests.list
	gen_cl_store_tests.py)
piglit_make_generated_tests(
	cl_vstore_tests.list
	gen_cl_vstore_tests.py)
piglit_make_generated_tests(
	cl_vload_tests.list
	gen_cl_vload_tests.py)
piglit_make_generated_tests(
	builtin_cl_math_tests.list
	gen_cl_math_builtins.py)
piglit_make_generated_tests(
	builtin_cl_relational_tests.list
	gen_cl_relational_builtins.py)
piglit_make_generated_tests(
	builtin_cl_common_tests.list
	gen_cl_common_builtins.py)
piglit_make_generated_tests(
	builtin_cl_shuffle_tests.list
	gen_cl_shuffle_builtins.py)
piglit_make_generated_tests(
	builtin_cl_shuffle2_tests.list
	gen_cl_shuffle2_builtins.py)

# Vulkan test generators.
piglit_make_generated_tests(
	vulkan_cmat_muladd_with_acc_constant.list
	gen_vulkan_cmat_muladd_with_acc_constant.py)

# Create a custom target for generating OpenGL tests
# This is not added to the default target, instead it is added
# as a dependency of gen-tests if OpenGL or OpenGLES{2,3} tests
# are enabled
add_custom_target(gen-gl-tests
	DEPENDS builtin_packing_tests.list
			outerproduct_tests.list
			outerproduct_invalid_params.list
			builtin_uniform_tests.list
			constant_array_size_tests.list
			const_builtin_equal_tests.list
			builtin_packing_tests.list
			tcs_input_tests.list
			tes_input_tests.list
			interpolation_tests.list
			non-lvalue_tests.list
			texture_query_lod_tests.list
			texture_lod_tests.list
			shader_bit_encoding_tests.list
			uniform-initializer_tests.list
			ubo_tests.list
			interpolation-qualifier-built-in-variable.list
			builtin_uniform_tests_fp64.list
			constant_array_size_tests_fp64.list
			inout_fp64.list
			flat_interpolation_qualifier.list
			conversion.list
			shader_precision_tests.list

=== replayer/CMakeLists.txt ===
# coding=utf-8
#
# Copyright 2012 Intel Corporation
# Copyright © 2020 Valve Corporation.
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# This permission notice shall be included in all copies or
# substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
# KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
# PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHOR(S) BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
# AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
# OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#
# SPDX-License-Identifier: MIT

set(piglit_replayer_script ${piglit_SOURCE_DIR}/replayer/replayer.py)
set(piglit_replayer_output_dir ${piglit_BINARY_DIR}/bin)

set(piglit_replayer_outputs
	${piglit_replayer_output_dir}/replayer.py
	)

set(piglit_replayer_depends
	${CMAKE_SOURCE_DIR}/replayer/replayer.py
	)

file(MAKE_DIRECTORY ${piglit_BINARY_DIR}/bin)

add_custom_command(
	OUTPUT ${piglit_replayer_outputs}
	DEPENDS ${piglit_replayer_depends}
	COMMAND ${CMAKE_COMMAND} -E copy ${piglit_replayer_script} ${piglit_replayer_output_dir}
	)

add_custom_target(piglit_replayer ALL
	DEPENDS ${piglit_replayer_outputs}
	)

install(PROGRAMS ${piglit_replayer_outputs} DESTINATION ${PIGLIT_INSTALL_LIBDIR}/bin)

=== cmake/target_api/CMakeLists.txt ===
# Copyright (c) 2010-2012 Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

# The no_api directory must precede the GL directories because it may build
# api-independent libraries on which the api-dependent targets rely.
add_subdirectory(no_api)

if(PIGLIT_BUILD_GL_TESTS)
	add_subdirectory(gl)
endif(PIGLIT_BUILD_GL_TESTS)

if(PIGLIT_BUILD_GLES1_TESTS)
	add_subdirectory(gles1)
endif(PIGLIT_BUILD_GLES1_TESTS)

if(PIGLIT_BUILD_GLES2_TESTS)
	add_subdirectory(gles2)
endif(PIGLIT_BUILD_GLES2_TESTS)

if(PIGLIT_BUILD_GLES3_TESTS)
	add_subdirectory(gles3)
endif(PIGLIT_BUILD_GLES3_TESTS)

if(PIGLIT_BUILD_CL_TESTS)
	add_subdirectory(cl)
endif(PIGLIT_BUILD_CL_TESTS)

=== tests/cl/CMakeLists.txt ===
include_directories(
	${OPENCL_INCLUDE_PATH}
	${piglit_SOURCE_DIR}/tests/util
)

link_libraries (
	piglitutil_${piglit_target_api}
	${OPENCL_opencl_LIBRARY}
)

if(PIGLIT_HAS_POSIX_CLOCK_MONOTONIC AND HAVE_LIBRT)
	link_libraries(rt)
endif()

function(piglit_cl_add_test)
	piglit_add_executable(${ARGV})
endfunction(piglit_cl_add_test)

function(piglit_cl_add_custom_test name)

	list(REMOVE_AT ARGV 0)
	piglit_cl_add_test(
		cl-custom-${name}
		${ARGV}
	)

endfunction(piglit_cl_add_custom_test)

function(piglit_cl_add_api_test name)

	list(REMOVE_AT ARGV 0)
	piglit_cl_add_test(
		cl-api-${name}
		${ARGV}
	)

endfunction(piglit_cl_add_api_test)

function(piglit_cl_add_program_test name)

	list(REMOVE_AT ARGV 0)
	piglit_cl_add_test(
		cl-program-${name}
		${ARGV}
	)

endfunction(piglit_cl_add_program_test)

function(piglit_cl_add_interop_test name)

	list(REMOVE_AT ARGV 0)
	piglit_cl_add_test(
		cl-interop-${name}
		${ARGV}
	)

endfunction(piglit_cl_add_interop_test)

add_subdirectory (custom)
add_subdirectory (api)
add_subdirectory (program)
add_subdirectory (interop)

=== tests/egl/CMakeLists.txt ===
piglit_include_target_api()
add_subdirectory(spec)

=== tests/spec/CMakeLists.txt ===
add_subdirectory (amd_compressed_atc_texture)
add_subdirectory (amd_framebuffer_multisample_advanced)
add_subdirectory (amd_depth_clamp_separate)
add_subdirectory (amd_gpu_shader_half_float)
add_subdirectory (amd_performance_monitor)
add_subdirectory (amd_pinned_memory)
add_subdirectory (apple_sync)
add_subdirectory (arb_arrays_of_arrays)
add_subdirectory (arb_base_instance)
add_subdirectory (arb_bindless_texture)
add_subdirectory (arb_buffer_storage)
add_subdirectory (arb_clear_buffer_object)
add_subdirectory (arb_clear_texture)
add_subdirectory (arb_clip_control)
add_subdirectory (arb_color_buffer_float)
add_subdirectory (arb_copy_image)
add_subdirectory (arb_compute_shader)
add_subdirectory (arb_compute_variable_group_size)
add_subdirectory (arb_cull_distance)
add_subdirectory (arb_debug_output)
add_subdirectory (khr_debug)
add_subdirectory (khr_texture_compression_astc)
add_subdirectory (oes_texture_compression_astc)
add_subdirectory (arb_depth_clamp)
add_subdirectory (arb_draw_indirect)
add_subdirectory (arb_draw_instanced)
add_subdirectory (arb_es2_compatibility)
add_subdirectory (arb_es3_compatibility)
add_subdirectory (arb_enhanced_layouts)
add_subdirectory (arb_explicit_attrib_location)
add_subdirectory (arb_explicit_uniform_location)
add_subdirectory (arb_framebuffer_no_attachments)
add_subdirectory (arb_framebuffer_object)
add_subdirectory (arb_framebuffer_srgb)
add_subdirectory (arb_geometry_shader4)
add_subdirectory (arb_get_program_binary)
add_subdirectory (arb_get_texture_sub_image)
add_subdirectory (arb_gpu_shader5)
add_subdirectory (arb_gpu_shader_fp64)
add_subdirectory (arb_instanced_arrays)
add_subdirectory (arb_internalformat_query)
add_subdirectory (arb_internalformat_query2)
add_subdirectory (arb_invalidate_subdata)
add_subdirectory (arb_map_buffer_alignment)
add_subdirectory (arb_map_buffer_range)
add_subdirectory (arb_multisample)
add_subdirectory (arb_occlusion_query)
add_subdirectory (arb_occlusion_query2)
add_subdirectory (arb_point_parameters)
add_subdirectory (arb_point_sprite)
add_subdirectory (arb_provoking_vertex)
add_subdirectory (arb_robustness)
add_subdirectory (arb_sample_locations)
add_subdirectory (arb_sample_shading)
add_subdirectory (arb_sampler_objects)
add_subdirectory (arb_seamless_cube_map)
add_subdirectory (amd_seamless_cubemap_per_texture)
add_subdirectory (amd_vertex_shader_layer)
add_subdirectory (amd_vertex_shader_viewport_index)
add_subdirectory (arb_separate_shader_objects)
add_subdirectory (arb_shader_subroutine)
add_subdirectory (arb_shader_texture_lod/execution)
add_subdirectory (arb_shader_atomic_counters)
add_subdirectory (arb_shader_objects)
add_subdirectory (arb_shader_image_load_store)
add_subdirectory (arb_shader_image_size)
add_subdirectory (arb_shading_language_420pack/execution)
add_subdirectory (arb_shading_language_include)
add_subdirectory (arb_stencil_texturing)
add_subdirectory (arb_sync)
add_subdirectory (arb_uniform_buffer_object)
add_subdirectory (ati_draw_buffers)
add_subdirectory (arb_sparse_buffer)
add_subdirectory (arb_tessellation_shader)
add_subdirectory (arb_texture_buffer_object)
add_subdirectory (arb_texture_buffer_range)
add_subdirectory (arb_texture_compression)
add_subdirectory (arb_texture_cube_map)
add_subdirectory (arb_texture_cube_map_array)
add_subdirectory (arb_texture_float)
add_subdirectory (arb_texture_rectangle)
add_subdirectory (arb_texture_multisample)
add_subdirectory (arb_texture_storage)
add_subdirectory (arb_texture_storage_multisample)
add_subdirectory (arb_texture_view)
add_subdirectory (arb_timer_query)
add_subdirectory (arb_transform_feedback2)
add_subdirectory (arb_transform_feedback3)
add_subdirectory (arb_transform_feedback_overflow_query)
add_subdirectory (arb_viewport_array)
add_subdirectory (ati_envmap_bumpmap)
add_subdirectory (ati_fragment_shader)
add_subdirectory (ext_depth_bounds_test)
add_subdirectory (ext_draw_instanced)
add_subdirectory (ext_external_objects)
add_subdirectory (ext_external_objects_fd)
add_subdirectory (ext_frag_depth)
add_subdirectory (ext_fog_coord)
add_subdirectory (ext_framebuffer_multisample)
add_subdirectory (ext_framebuffer_multisample_blit_scaled)
add_subdirectory (ext_framebuffer_object)
add_subdirectory (ext_gpu_shader4)
add_subdirectory (ext_multi_draw_indirect)
add_subdirectory (ext_packed_depth_stencil)
add_subdirectory (ext_packed_float)
add_subdirectory (ext_shader_image_load_store)
add_subdirectory (ext_shader_samples_identical)
add_subdirectory (ext_texture_env_combine)
add_subdirectory (ext_texture_storage_compression)
add_subdirectory (ext_texture_swizzle)
add_subdirectory (ext_timer_query)
add_subdirectory (ext_transform_feedback)
add_subdirectory (nv_conditional_render)
add_subdirectory (nv_fill_rectangle)
add_subdirectory (nv_fog_distance)
add_subdirectory (nv_image_formats)
add_subdirectory (nv_primitive_restart)
add_subdirectory (nv_texture_barrier)
add_subdirectory (nv_texture_env_combine4)
add_subdirectory (oes_compressed_etc1_rgb8_texture)
add_subdirectory (oes_compressed_paletted_texture)
add_subdirectory (oes_required_internalformat)
add_subdirectory (oes_matrix_get)
add_subdirectory (arb_draw_elements_base_vertex)
add_subdirectory (arb_fragment_program)
add_subdirectory (arb_vertex_array_bgra)
add_subdirectory (arb_vertex_buffer_object)
add_subdirectory (arb_vertex_program)
add_subdirectory (arb_copy_buffer)
add_subdirectory (arb_shader_storage_buffer_object)
add_subdirectory (glsl-1.10)
add_subdirectory (glsl-1.20)
add_subdirectory (glsl-1.30)
add_subdirectory (glsl-1.40)
add_subdirectory (glsl-1.50)
add_subdirectory (glsl-es-1.00)
add_subdirectory (glsl-es-3.00)
add_subdirectory (gl-1.0)
add_subdirectory (gl-1.1)
add_subdirectory (gl-1.2)
add_subdirectory (gl-1.3)
add_subdirectory (gl-1.4)
add_subdirectory (gl-1.5)
add_subdirectory (gl-2.0)
add_subdirectory (gl-2.1)
add_subdirectory (gl-3.0)
add_subdirectory (gl-3.1)
add_subdirectory (gl-3.2)
add_subdirectory (gl-3.3)
add_subdirectory (gl-4.1)
add_subdirectory (gl-4.3)
add_subdirectory (gl-4.4)
add_subdirectory (gl-4.5)
add_subdirectory (gles-2.0)
add_subdirectory (gles-3.0)
add_subdirectory (glx_arb_create_context)
add_subdirectory (glx_ext_import_context)
add_subdirectory (glx_mesa_query_renderer)
add_subdirectory (glx_oml_sync_control)
add_subdirectory (arb_vertex_type_10f_11f_11f_rev)
add_subdirectory (arb_vertex_type_2_10_10_10_rev)
add_subdirectory (ext_clear_texture)
add_subdirectory (ext_texture_array)
add_subdirectory (ext_texture_integer)
add_subdirectory (arb_draw_buffers)
add_subdirectory (arb_draw_buffers_blend)
add_subdirectory (oes_draw_texture)
add_subdirectory (oes_fixed_point)
add_subdirectory (ext_image_dma_buf_import)
add_subdirectory (arb_program_interface_query)
add_subdirectory (arb_blend_func_extended)
add_subdirectory (ext_unpack_subimage)
add_subdirectory (arb_vertex_array_object)
add_subdirectory (oes_texture_float)
add_subdirectory (arb_direct_state_access)
add_subdirectory (ext_polygon_offset_clamp)
add_subdirectory (arb_pipeline_statistics_query)
add_subdirectory (arb_texture_stencil8)
add_subdirectory (arb_vertex_attrib_64bit)
add_subdirectory (ext_framebuffer_blit)
add_subdirectory (mesa_pack_invert)
add_subdirectory (ext_texture_format_bgra8888)
add_subdirectory (oes_draw_elements_base_vertex)
add_subdirectory (arb_shader_draw_parameters)
add_subdirectory (arb_indirect_parameters)
add_subdirectory (arb_query_buffer_object)
add_subdirectory (ext_window_rectangles)
add_subdirectory (arb_shader_texture_image_samples)
add_subdirectory (arb_texture_barrier)
add_subdirectory (intel_conservative_rasterization)
add_subdirectory (arb_post_depth_coverage)
add_subdirectory (arb_fragment_shader_interlock)
add_subdirectory (ext_occlusion_query_boolean)
add_subdirectory (ext_disjoint_timer_query)
add_subdirectory (intel_blackhole_render)
add_subdirectory (ext_texture_norm16)
add_subdirectory (ext_render_snorm)
add_subdirectory (ext_texture_compression_bptc)
add_subdirectory (ext_texture_compression_rgtc)
add_subdirectory (ext_color_buffer_float)
add_subdirectory (ext_debug_label)
add_subdirectory (khr_parallel_shader_compile)
add_subdirectory (ext_direct_state_access)
add_subdirectory (arb_gpu_shader_int64)
add_subdirectory (oes_egl_image_external_essl3)
add_subdirectory (intel_performance_query)
add_subdirectory (nv_copy_image)
add_subdirectory (nv_viewport_swizzle)
add_subdirectory (nv_alpha_to_coverage_dither_control)
add_subdirectory (nv_copy_depth_to_color)
add_subdirectory (arm_shader_framebuffer_fetch_depth_stencil)
add_subdirectory (ext_instanced_arrays)
add_subdirectory (ext_texture_storage)
add_subdirectory (ovr_multiview)

=== cmake/target_api/gl/CMakeLists.txt ===
set(piglit_target_api "gl")
add_definitions(
	-DPIGLIT_USE_OPENGL
	)

if(NOT PIGLIT_USE_WAFFLE)
	add_definitions(-DPIGLIT_USE_GLUT)
	include_directories(
		${GLUT_INCLUDE_DIR}
		)
	link_libraries(
		${GLUT_glut_LIBRARY}
		)

	# Check if glutInitErrorFunc is available
	if (NOT APPLE)
		include(CheckSymbolExists)
		set(CMAKE_REQUIRED_INCLUDES "${GLUT_INCLUDE_DIR}")
		set(CMAKE_REQUIRED_LIBRARIES "${GLUT_glut_LIBRARY}")
		check_symbol_exists ("glutInitErrorFunc" "GL/glut.h;GL/freeglut_ext.h" PIGLIT_USE_GLUT_INIT_ERROR_FUNC)
		if (PIGLIT_USE_GLUT_INIT_ERROR_FUNC)
			add_definitions(-DPIGLIT_USE_GLUT_INIT_ERROR_FUNC)
		endif ()
	endif ()
endif()

add_subdirectory(${piglit_SOURCE_DIR}/tests
	${piglit_BINARY_DIR}/target_api/${piglit_target_api}/tests
	)

=== cmake/target_api/gles1/CMakeLists.txt ===
set(piglit_target_api "gles1")

add_definitions(
	-DPIGLIT_USE_OPENGL_ES1
	)
add_subdirectory(${piglit_SOURCE_DIR}/tests
	${piglit_BINARY_DIR}/target_api/${piglit_target_api}/tests
	)

=== cmake/target_api/gles3/CMakeLists.txt ===
set(piglit_target_api "gles3")

add_definitions(
	-DPIGLIT_USE_OPENGL_ES3
	)
add_subdirectory(${piglit_SOURCE_DIR}/tests
	${piglit_BINARY_DIR}/target_api/${piglit_target_api}/tests
	)

=== tests/egl/spec/CMakeLists.txt ===
add_subdirectory (egl-1.4)
add_subdirectory (egl_ext_client_extensions)
add_subdirectory (egl_ext_device_base)
add_subdirectory (egl_ext_device_query)
add_subdirectory (egl_ext_device_enumeration)
add_subdirectory (egl_ext_device_drm)
add_subdirectory (egl_ext_platform_device)
add_subdirectory (egl_ext_image_dma_buf_import_modifiers)
add_subdirectory (egl_ext_protected_content)
add_subdirectory (egl_ext_surface_compression)
add_subdirectory (egl_khr_create_context)
add_subdirectory (egl_khr_display_reference)
add_subdirectory (egl_khr_get_all_proc_addresses)
add_subdirectory (egl_khr_gl_image)
add_subdirectory (egl_khr_fence_sync)
add_subdirectory (egl_khr_surfaceless_context)
add_subdirectory (egl_mesa_device_software)
add_subdirectory (egl_mesa_platform_surfaceless)
add_subdirectory (egl_mesa_query_driver)

if (PIGLIT_HAS_X11)
	add_subdirectory (egl_chromium_sync_control)
endif (PIGLIT_HAS_X11)

=== tests/spec/glsl-1.20/CMakeLists.txt ===
piglit_include_target_api()

add_subdirectory (recursion)

=== debian/changelog ===
piglit (0.0~git20250409.af62c0dea-2) unstable; urgency=medium

  * d/patches: Add patch to fix upstream FTBFS 32-bit issue

 -- Jordan Justen <jljusten@debian.org>  Mon, 14 Apr 2025 15:36:14 -0700

piglit (0.0~git20250409.af62c0dea-1) unstable; urgency=medium

  * Update piglit upstream version to af62c0dea
  * d/control: Set Standards-Version to 4.7.2

 -- Jordan Justen <jljusten@debian.org>  Mon, 14 Apr 2025 02:27:01 -0700

=== debian/control ===
Source: piglit
Priority: optional
Section: devel
Maintainer: Jordan Justen <jljusten@debian.org>
Build-Depends: bash-completion,
               binutils (>> 2.18),
               cmake,
               debhelper-compat (= 13),
               dh-python,
               glslang-tools,
               libegl1-mesa-dev | libegl-dev,
               libgbm-dev,
               libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libvulkan-dev,
               libwaffle-dev (>= 1.3),
               libxcb-dri2-0-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               ninja-build,
               ocl-icd-opencl-dev | opencl-dev,
               pkgconf,
               python3,
               python3-mako,
               python3-numpy,
               python3-six,
               wayland-protocols
Standards-Version: 4.7.2
Homepage: http://piglit.freedesktop.org/
Vcs-Git: https://salsa.debian.org/xorg-team/app/piglit.git
Vcs-Browser: https://salsa.debian.org/xorg-team/app/piglit

Package: piglit
Architecture: any
Depends: python3-mako,
         python3-six,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: waffle-utils
Description: Open-source test suite for OpenGL and OpenCL implementations
 Piglit is an open-source test suite for OpenGL and OpenCL implementations.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright (c) 2014 Intel Corporation

DEB_DESTDIR := $(CURDIR)/debian/piglit

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem cmake+ninja --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_BUILD_TYPE=Release \
		-DPIGLIT_BUILD_GLES1_TESTS=1 \
		-DPIGLIT_BUILD_GLES2_TESTS=1 \
		-DPIGLIT_BUILD_GLES3_TESTS=1 \
		-DPIGLIT_BUILD_CL_TESTS=1 \
		-DPIGLIT_USE_WAFFLE=1

override_dh_auto_install:
	dh_auto_install
	find $(DEB_DESTDIR) -type d -name __pycache__ -exec rm -r {} +
	find $(DEB_DESTDIR) -type d -empty -delete
	python3 $(CURDIR)/debian/update-piglit-script.py $(DEB_DESTDIR)/usr/bin/piglit

override_dh_makeshlibs:
#       Fix lintian extra-license-file
	rm $(DEB_DESTDIR)/usr/share/doc/piglit/COPYING.gz

override_dh_auto_test:
	# renderdoc doesn't appear to have tests, and the ninja
	# generator of cmake fails when 'ninja test' is run.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://gitlab.freedesktop.org/mesa/piglit.git \
HEAD
